﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.Collections.ObjectModel
Imports System.IO
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary
<Serializable()>
Public Class Form1
   Private moSQLLayer As MsSql2008FeatureLayer
   Dim sInstructions As String =
   "1. When you click the button the application attempts to load a layer from SQL Server." & ControlChars.CrLf & ControlChars.CrLf &
   "2. The SQL Server layer that causes a problem seems to be any layer that has only ONE feature." & ControlChars.CrLf & ControlChars.CrLf &
   "3. When GetBoundingBox is called on the SQL Server layer a timeout occurs. I tried increasing the timeout to 10 minutes and it still timed out." & ControlChars.CrLf & ControlChars.CrLf &
   "4. You will have to alter the code to point to a server and layer with only ONE feature in it."

   Private Sub LoadSQLSpatialLayer()
      Dim oOverlay As LayerOverlay
      Dim sConnect As String = "Data Source=STEVEM6500\WILDBIRD;Initial Catalog=FieldIFMS;Integrated Security=True;User ID=;Password="
      Dim oAreaStyle As AreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue, 1, LineDashStyle.Solid, 0, 0)
      moSQLLayer = New MsSql2008FeatureLayer(sConnect, "ORG", "OBJECTID", 26916)
      Dim oMap As WinformsMap = WinformsMap1

      oOverlay = New LayerOverlay
      oMap.Overlays.Add("ORG", oOverlay)

      moSQLLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = oAreaStyle
      moSQLLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      moSQLLayer.Name = "ORG"

      oOverlay.Layers.Add(moSQLLayer.Name, moSQLLayer)

      oMap.MapUnit = GeographyUnit.Meter

      Try
         moSQLLayer.Open()
         oMap.CurrentExtent = moSQLLayer.GetBoundingBox
         moSQLLayer.Close()
         oMap.Refresh()
      Catch ex As Exception
         MessageBox.Show("Error: " & ex.Message)
      End Try
   End Sub

   Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
      TextBox1.Text = sInstructions
   End Sub

   Private Sub btnLoad_Click(sender As System.Object, e As System.EventArgs) Handles btnLoad.Click
      LoadSQLSpatialLayer()
   End Sub
End Class
